      integer, parameter :: ddp = selected_real_kind(15)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC    Resummation coefficients QCD
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      real(ddp):: beta0,beta1,beta2 
      real(ddp):: Kappa
      real(ddp):: A1q,A2q,B1q,B2q,A3q,A1g,B1g,A2g
      real(ddp):: C1qqdelta,Delta2qq,D0qqqq,D1qqqq,Deltaqqqq
      real(ddp):: H2qqdelta,H2qqD0
      integer  :: nnf,CAH
      real(ddp):: ppi,ZZ3,ZZ2,ZZ4,ZZ5
      real(dp) :: PolyLog2m25,PolyLog3m25,PolyLog4m25
      real(dp) :: PolyLog2m10,PolyLog3m5,PolyLog2m5,PolyLog4m5
      real(dp) :: PolyLog4m10,PolyLog4m2,PolyLog2m2,PolyLog3m10,PolyLog3m2
      real(ddp):: H1qDYHSCHM,H2qDYHSCHM,H3qDYHSCHM
      real(ddp):: H1gHHSCHM,H2gHHSCHM,H3gHHSCHM
      real(ddp):: B2qHSCHM,B2gHSCHM,B3qHSCHM,B3gHSCHM
      real(ddp):: CFH
      real(ddp):: NNc,NNc2,NNfV
      real(ddp):: dg2,gamma2g,A3g,Delta2gg,D0gggg,D1gggg,Deltagggg
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC    Resummation coefficients QED
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      real(ddp):: beta0p,beta1p,beta01p
      real(ddp):: A01q,A02q,B01q,A11q
      real(ddp):: H01qDYHSCHM,H02qDYHSCHM,H11qDYHSCHM
      real(ddp):: B02qHSCHM,B11qHSCHM
      real(ddp):: NN2,gammacoeff1mix
      real(ddp):: Delta11qq,Delta02qq
      real(ddp):: D0qqqqmix,D1qqqqmix,Deltaqqqqmix
      real(ddp):: D0qqqqqed,D1qqqqqed,Deltaqqqqqed
      real(ddp):: Kappamix
      real(ddp):: H02qqD0,H11qqD0
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c     nnf dependence included only here and it is not conected
c     to the main routine 
      parameter(nnf=5)
      parameter(CAH=3)
      parameter(CFH=4._ddp/3._ddp)
      parameter(ppi=3.14159265358979_ddp)
      parameter(ZZ3=1.20205690315959429_ddp)
      parameter(ZZ2=ppi**2/6._ddp)
      parameter(ZZ4=ppi**4/90._ddp)
      parameter(ZZ5=1.03692775514337_ddp)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      parameter(beta0=(33._ddp-2._ddp*nnf)/12._ddp)
      parameter(beta1=(153._ddp-19._ddp*nnf)/24._ddp)
      parameter(beta2=(((2857._ddp*CA**3)/54._ddp - (1415._ddp*CA**2*nNf)/54._ddp - 
     &    (205._ddp*CA*CF*nNf)/18._ddp + CF**2*nNf + (79._ddp*CA*nNf**2)/54._ddp + 
     &    (11._ddp*CF*nNf**2)/9._ddp)/64._ddp))
      parameter(Kappa=67._ddp/6._ddp-(ppi**2)/2._ddp-5._ddp/9._ddp*nnf)
      parameter(A1q=4._ddp/3._ddp)
      parameter(A1g=CA)
      parameter(A2q=0.5_ddp*A1q*Kappa)
      parameter(A2g=0.5_ddp*A1g*Kappa)
      parameter(B1g=-2._ddp*beta0)
      parameter(B1q=-2._ddp)
c     B2q OLD SCHEME      
      parameter(B2q=4._ddp/9._ddp*(ppi**2-3._ddp/4._ddp-12._ddp*ZZ3)+
     & (11._ddp/9._ddp*ppi**2)
     & -193._ddp/12._ddp+6._ddp*ZZ3+nnf/6._ddp*
     & (17._ddp/3._ddp-4._ddp/9._ddp*ppi**2))
C     Delta term in c1qq coefficient  OLD SCHEME
      parameter(C1qqdelta=(ppi**2-8._ddp)/3._ddp)
C     Delta term in P2qq splitting function (as/pi normalization)
      parameter(Delta2qq=(16._ddp/9._ddp*(3._ddp/8._ddp-ppi**2/2._ddp
     & +6._ddp*ZZ3)
     &   +4._ddp*(17._ddp/24._ddp+11._ddp*ppi**2/18._ddp-3._ddp*ZZ3)
     & -2._ddp/3._ddp*nnf*(1._ddp/6._ddp+2._ddp*ppi**2/9._ddp))/4._ddp)
CC    Coefficients of D0 and D1 in P*P (as/pi normalization)
      parameter(D0qqqq=8._ddp/3._ddp)
      parameter(D1qqqq=32._ddp/9._ddp)
C     Delta term in P2gg splitting function (as/pi normalization)
      parameter(Delta2gg=(9._ddp*(8._ddp/3._ddp+3._ddp*ZZ3)-2._ddp/3*nnf-2._ddp*nnf)/4._ddp)
CC    Coefficients of D0 and D1 in P*P (as/pi normalization)
      parameter(D0gggg=6._ddp*beta0) 
      parameter(D1gggg=18._ddp)
CC    Coefficients of delta(1-z) in P*P
      parameter(Deltagggg=beta0**2-3._ddp/2._ddp*ppi**2)
C     H2gg contribution: coefficient of delta(1-z)
CC    Coefficients of delta(1-z) in P*P
      parameter(Deltaqqqq=4._ddp/9._ddp*
     & (9._ddp/4._ddp-2._ddp*ppi**2/3._ddp))
C     H2qq contribution: coefficient of delta(1-z) OLD SCHEME
      parameter(H2qqdelta=-2561._ddp/144._ddp+127._ddp*nnf/72._ddp
     & +3._ddp*ppi**2/2._dp
     &      -19._ddp*nnf*ppi**2/81._ddp+49._ddp*ppi**4/324._ddp 
     & +58._ddp*ZZ3/9._dp 
     & + 8._ddp*nnf*ZZ3/27._ddp)
C     H2qq contribution: coefficient of D0(z)
      parameter(H2qqD0=-404._ddp/27._ddp+(56._ddp*nnf)/81._ddp
     & +14._ddp*ZZ3)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     QCD
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      parameter(H1qDYHSCHM=2._ddp*(ppi**2-8._ddp)/3._ddp)
      parameter(H1gHHSCHM=2._ddp*(11._ddp+3._ddp*ppi**2)/4._ddp)
      parameter(H2qDYHSCHM=H2qqdelta)
c      parameter(H2gHHSCHM= in CalcqTsubComp_ggfus.f)
c      parameter(H3gHHSCHM= in CalcqTsubComp_ggfus.f)
      parameter(B2qHSCHM=(1.0_ddp/48.0_ddp)*CFH*(2.0_ddp*nnf*(1.0_ddp 
     & + 4.0_ddp*ZZ2) +   
     &  9.0_ddp*CFH*(-1.0_ddp + 8.0_ddp*ZZ2 - 16.0_ddp*ZZ3) 
     & +    3.0_ddp*(-17.0_ddp - 44.0_ddp*ZZ2 + 72.0_ddp*ZZ3)))
      parameter(B2gHSCHM=1._ddp/24._ddp*(33._ddp*ppi**2 
     & - 2._ddp*nnf*(-16._ddp + ppi**2) - 
     & 36._ddp*(8._ddp + 9._ddp*ZZ3)))
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                     MIXED QED X QCD CONTRIBUTIONS
C     QED   Normalized to the global Charge^2 for Mixed
c     QED   at NNLO nor ready!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c     Everything with as/pi normalization
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C ********************************************************************* 
CC    Coefficients of D0 and D1 in P*PQED (as/pi normalization)
      parameter(D0qqqqmix=8._ddp/3._ddp/CFH)
      parameter(D1qqqqmix=32._ddp/9._ddp/CFH)
CC    Coefficients of delta(1-z) in P*PQED
      parameter(Deltaqqqqmix=(4._ddp/9._ddp*
     & (9._ddp/4._ddp-2._ddp*ppi**2/3._ddp))/CFH)
C ********************************************************************* 
CC    Coefficients of D0 and D1 in P*PQED (as/pi normalization)
CC    ! It is the MIXED Coefficient yet NOT READY!!!!!!!!!!!!!!!!!!!!!!
      parameter(D0qqqqqed=8._ddp/3._ddp/CFH)
      parameter(D1qqqqqed=32._ddp/9._ddp/CFH)
CC    Coefficients of delta(1-z) in P*PQED
      parameter(Deltaqqqqqed=(4._ddp/9._ddp*
     & (9._ddp/4._ddp-2._ddp*ppi**2/3._ddp))/CFH)
C *********************************************************************     
C     Delta term in P11qq splitting function (as/pi normalization)
C ********************************************************************* 
      parameter(Delta11qq=(2._ddp*CFH*(3._ddp/8._ddp-ppi**2/2._ddp
     & +6._ddp*ZZ3))/4._ddp)
C *********************************************************************     
C     Delta term in P02qq splitting function (as/pi normalization)
C ********************************************************************* 
      parameter(Delta02qq=(2._ddp*CFH*(3._ddp/8._ddp-ppi**2/2._ddp
     & +6._ddp*ZZ3))/4._ddp)! It is the MIXED Coefficient yet NOT READY!
C *********************************************************************      
      ! NN2 = NN(2) For 5 quark flavours and 3 lepton flavours
      ! NN(i) = Nc Sum_(k=1)^nnf[eq_k^(i)] + Sum_(k=1)^nl[el_k^(i)] 
      parameter(NN2  = 3._ddp*11._ddp/9._ddp+3._ddp)
C *********************************************************************
C     H02qq contribution: coefficient of D0(z) NOT READY!!!!!!!!!!!!!!!
      parameter(H02qqD0=(-101*CAH*CFH)/27. + (14*CFH*nnf)/27. 
     & + (7*CAH*CFH*ZZ3)/2.) ! It is the QCD Coefficient yet
C *********************************************************************     
C     H11qq contribution: coefficient of D0(z) Only Survives CF^2
      parameter(H11qqD0=0._ddp)
C *********************************************************************                
      parameter(A01q = 1._ddp)
      parameter(A02q =-5._ddp/9._ddp*NN2)
      parameter(B01q =-3._ddp/2._ddp)
      parameter(A11q = 0._ddp)
      parameter(Kappamix = 0._ddp)
      ! Beta0 QED is set to 0 if alpha_QED is not running
      parameter(beta0p=0._ddp)
      parameter(beta01p=0._ddp)
      parameter(H01qDYHSCHM=(2._ddp*(ppi**2-8._ddp)/3._ddp)/CFH)
      parameter(H11qDYHSCHM=2._ddp*CFH*(31.9375 - (67*Pi**2)/12. 
     & + (17*Pi**4)/45. - 15*ZZ3)/4.)
      parameter(H02qDYHSCHM= 0._ddp) ! NOT READY!!!!!!!!!!!!!!!
      parameter(gammacoeff1mix = 2._ddp*CFH*(4._dp*ppi**2
     &                          -3._ddp-48._ddp*ZZ3))
      parameter(B02qHSCHM=0._ddp)
      parameter(B11qHSCHM=gammacoeff1mix/16._ddp) ! From Eq. (34) Univ
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCC                                     CCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCC              N3LO                   CCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCC                                     CCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      parameter(B3qHSCHM = (-4623*CF)/32._ddp 
     -   + (20149*CA**2*CF)/1152. - (29*CF**2)/8._ddp + 
     -  (11*CA*CF**2)/384._ddp - (29*CF**3)/64._ddp + (763*CF*nnf)/48._ddp - 
     -  (853*CA*CF*nnf)/144._ddp + (23*CF**2*nnf)/32._ddp + (17*CF*nnf**2)/288._ddp + 
     -  (1295*CF*Pi**2)/72._ddp - (353*CA**2*CF*Pi**2)/162._ddp + 
     -  (131*CF**2*Pi**2)/24._ddp - (319*CA*CF**2*Pi**2)/288._ddp - 
     -  (3*CF**3*Pi**2)/32._ddp - (469*CF*nnf*Pi**2)/216._ddp + 
     -  (983*CA*CF*nnf*Pi**2)/1296._ddp - (CF**2*nnf*Pi**2)/18._ddp - 
     -  (251*CF*Pi**4)/480._ddp + (11*CA**2*CF*Pi**4)/1440._ddp + 
     -  (CF**2*Pi**4)/288._ddp + (121*CA*CF**2*Pi**4)/2160._ddp - 
     -  (CF**3*Pi**4)/20._ddp + (11*CF*nnf*Pi**4)/360._ddp - 
     -  (CA*CF*nnf*Pi**4)/720._ddp - (29*CF**2*nnf*Pi**4)/2160._ddp + 
     -  (2825*CF*ZZ3)/24._ddp - (649*CA**2*CF*ZZ3)/108._ddp - 47*CF**2*ZZ3 + 
     -  (55*CA*CF**2*ZZ3)/8._ddp - (17*CF**3*ZZ3)/8._ddp - (215*CF*nnf*ZZ3)/36._ddp + 
     -  (37*CA*CF*nnf*ZZ3)/54._ddp + (17*CF**2*nnf*ZZ3)/12._ddp + 
     -  (CF*nnf**2*ZZ3)/9._ddp - (CF**2*Pi**2*ZZ3)/4._ddp + (CF**3*Pi**2*ZZ3)/6._ddp - 
     -  (45*CF*ZZ5)/4._ddp - (45*CF**2*ZZ5)/4._ddp + (15*CF**3*ZZ5)/2._ddp)
      parameter(A3q = (15503*CA**2*CF)/2592._ddp - (2051*CA*CF*nnf)/1296._ddp - 
     -  (55*CF**2*nnf)/96._ddp + (25*CF*nnf**2)/324._ddp - 
     -  (67*CA**2*CF*Pi**2)/216._ddp + (5*CA*CF*nnf*Pi**2)/108._ddp + 
     -  (11*CA**2*CF*Pi**4)/720._ddp - (11*CA**2*CF*ZZ3)/4._ddp + 
     -  (CF**2*nnf*ZZ3)/2._ddp) 
      parameter(Gamma2g = 4._ddp*CA*(CA**2 *(245._ddp/6._ddp - 134._ddp*pi**2/27._ddp
     . + 11._ddp*Pi**4 /45._ddp + 22._ddp*ZZ3/3._ddp) + CA*TR*nnf*(-418._ddp/27._ddp
     . + 40._ddp*Pi**2/27._ddp - 56._ddp*ZZ3/3._ddp) + CF*TR*nnf*(-55._ddp/3._ddp+ 16._ddp
     . * ZZ3) - 16._ddp/27._ddp * TR**2 * nnf**2))
      parameter(dg2 = CA*(CA*(808._ddp/27._ddp - 28._ddp*ZZ3)
     &  - 224._ddp/27._ddp*TR*nnf))
      parameter(A3g = (Gamma2g + 2._ddp *(4._ddp*Beta0) * dg2)/64._ddp)
      parameter(B3gHSCHM =-2133._ddp/64._ddp + (3029._ddp*nnf)/576._ddp - (349._ddp*nnf**2)/1728._ddp +
     &  (109._ddp*Pi**2)/6._ddp - (283._ddp*nnf*Pi**2)/144._ddp + (5*nnf**2*Pi**2)/108._ddp -
     &  (253._ddp*Pi**4)/160._ddp + (23._ddp*nnf*Pi**4)/240._ddp - (843*ZZ3)/8._ddp + 2._ddp*nnf*ZZ3 +
     &  (nnf**2*ZZ3)/6._ddp + (9._ddp*Pi**2*ZZ3)/4._ddp + (135._ddp*ZZ5)/2._ddp)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      parameter(NNc=CA)
      parameter(NNc2=CA*CA)
      parameter(NnfV=nnf)
      parameter(H3qDYHSCHM=11.614189592541788_ddp - 
     & (102053833._ddp*CA**2*CF)/3.359232e6_ddp - 
     -  (2539._ddp*CF**2)/384._ddp + (824281._ddp*CA*CF**2)/20736._ddp - 
     -  (255._ddp*CF**3)/32._ddp + (27169931._ddp*CA*CF*nnf)/3.359232e6_ddp - 
     -  (228581._ddp*CF**2*nnf)/124416._ddp - (190931._ddp*CF*nnf**2)/419904._ddp - 
     -  (CF*nnfV)/(2._ddp*NNc) + (CF*nnfV*NNc2)/(8._ddp*NNc) + 
     -  (145813._ddp*Pi**2)/69984._ddp + (522155._ddp*CA**2*CF*Pi**2)/139968._ddp - 
     -  (6451._ddp*CF**2*Pi**2)/4608._ddp - 
     -  (406507._ddp*CA*CF**2*Pi**2)/62208._ddp + (1681*CF**3*Pi**2)/512._ddp - 
     -  (179879._ddp*CA*CF*nnf*Pi**2)/139968._ddp + 
     -  (15163._ddp*CF**2*nnf*Pi**2)/15552._ddp + 
     -  (403._ddp*CF*nnf**2*Pi**2)/3888._ddp - (5*CF*nnfV*Pi**2)/(24._ddp*NNc) + 
     -  (5._ddp*CF*nnfV*NNc2*Pi**2)/(96._ddp*NNc) - (52559*Pi**4)/116640._ddp - 
     -  (4303._ddp*CA**2*CF*Pi**4)/311040._ddp - (413._ddp*CF**2*Pi**4)/5760._ddp + 
     -  (92237._ddp*CA*CF**2*Pi**4)/155520._ddp - 
     -  (1663._ddp*CF**3*Pi**4)/5760._ddp - (35._ddp*CA*CF*nnf*Pi**4)/15552._ddp - 
     -  (1463._ddp*CF**2*nnf*Pi**4)/15552._ddp + 
     -  (43._ddp*CF*nnf**2*Pi**4)/38880._ddp + (CF*nnfV*Pi**4)/(720._ddp*NNc) - 
     -  (CF*nnfV*NNc2*Pi**4)/(2880._ddp*NNc) - (13607._ddp*Pi**6)/612360._ddp + 
     -  (299._ddp*CA**2*CF*Pi**6)/102060._ddp + 
     -  (37729._ddp*CF**2*Pi**6)/4.35456e6_ddp - 
     -  (739._ddp*CA*CF**2*Pi**6)/54432._ddp + (1141._ddp*CF**3*Pi**6)/69120._ddp - 
     -  (188029._ddp*ZZ3)/2916._ddp + 
     -  (505087._ddp*CA**2*CF*ZZ3)/15552._ddp - 
     -  (235._ddp*CF**2*ZZ3)/16._ddp - (13141._ddp*CA*CF**2*ZZ3)/432._ddp + 
     -  (15._ddp*CF**3*ZZ3)/2._ddp - (134._ddp*CA*CF*nnf*ZZ3)/27._ddp + 
     -  (815._ddp*CF**2*nnf*ZZ3)/162._ddp - (13._ddp*CF*nnf**2*ZZ3)/243._ddp - 
     -  (7._ddp*CF*nnfV*ZZ3)/(12._ddp*NNc) + 
     -  (7._ddp*CF*nnfV*NNc2*ZZ3)/(48._ddp*NNc) + 
     -  (455._ddp*Pi**2*ZZ3)/1944._ddp - 
     -  (73._ddp*CA**2*CF*Pi**2*ZZ3)/36._ddp + 
     -  (125._ddp*CF**2*Pi**2*ZZ3)/96._ddp + 
     -  (845._ddp*CA*CF**2*Pi**2*ZZ3)/288._ddp - 
     -  (65*CF**3*Pi**2*ZZ3)/32._ddp + 
     -  (37._ddp*CA*CF*nnf*Pi**2*ZZ3)/144._ddp - 
     -  (37._ddp*CF**2*nnf*Pi**2*ZZ3)/144._ddp + (58._ddp*ZZ3**2)/3._ddp - 
     -  (71._ddp*CA**2*CF*ZZ3**2)/18._ddp+ (CF**2*ZZ3**2)/2._ddp + 
     -  (37._ddp*CA*CF**2*ZZ3**2)/12._ddp + (7087._ddp*ZZ5)/324._ddp - 
     -  (217._ddp*CA**2*CF*ZZ5)/144._ddp + (83._ddp*CF**2*ZZ5)/4._ddp - 
     -  (689._ddp*CA*CF**2*ZZ5)/72._ddp - (CA*CF*nnf*ZZ5)/24._ddp - 
     -  (13._ddp*CF**2*nnf*ZZ5)/9._ddp + (10._ddp*CF*nnfV*ZZ5)/(3._ddp*NNc) - 
     -  (5._ddp*CF*nnfV*NNc2*ZZ5)/(6._ddp*NNc))
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c      //N[PolyLog[2, -25]] 
      parameter(PolyLog2m25= -6.785907899712118_ddp)
c      // N[PolyLog[3, -25]]
      parameter(PolyLog3m25=-10.893189584831829_ddp)
c      //N[PolyLog[4, -25]]
      parameter(PolyLog4m25=-14.848948252983412_ddp)
c      // (*N[PolyLog[2,-10]]*)
      parameter(PolyLog2m10=  4.198277886858104_ddp)
c      // (*N[PolyLog[3,-10]]*)
      parameter(PolyLog3m10= -5.921064803756975_ddp)
c      // (*N[PolyLog[3,-5]]*)
      parameter(PolyLog3m5=  -3.537511437618607_ddp)
c      // (*N[PolyLog[2,-5]]*)
      parameter(PolyLog2m5=  -2.749279126060808_ddp)
c      // (*N[PolyLog[4,-5]]*)
      parameter(PolyLog4m5=   -4.10646797909497_ddp)
c      // (*N[PolyLog[4,-10]]*)
      parameter(PolyLog4m10= -7.326570248027082_ddp)
c      // (*N[PolyLog[4,-2]]*)
      parameter(PolyLog4m2=  -1.813126015328491_ddp)
c      // (* N[PolyLog[3,-2]]*)
      parameter(PolyLog3m2= -1.6682833639665713_ddp)
c      // (*N[PolyLog[2,-2]]*)
      parameter(PolyLog2m2= -1.4367463668836808_ddp)

      
